/*
 * eventos.c
 *
 * Linball - un pinball 2D multiplataforma escrito en C + SDL (desarrollado en Linux)
 *
 *
 * Copyright (c) 2007-2008 by Rafael Ignacio Zurita <rizurita@yahoo.com>
 * Copyright (c) 2007-2008 by Miriam Lechner <lechnermiriam@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

void play_sound(Mix_Chunk *sonido, int volumen) {
	int phaserChannel = -1;
	if (enable_sound) {
                phaserChannel = Mix_PlayChannel(-1, sonido, 0);
     //           Mix_VolumeChunk(sonido, volumen);
	}
}

void manejador_mouse(int x, int y) {
	int alt;	/* altura utilizada como incremento en el golpe de los
			   flippers a la bola. alt = pelotay - 1050 */

	if ((y>200) && (x<105)) {
	   	/* chequeamos si se acaba de pulsar la tecla */
		if (layout[flipper_Lup]->visible != 1){

			/* reproducir sonido de un flipper yendo hacia arriba */
                	play_sound(layout[flipper_Lup]->sonido, 128);

			/* chequeamos si la bola se encuentra en posicion 
			 * de impacto del flipper, entonces le damos potencia 
			 * y direccion
			 * flipper 1 y2 = 1110
			 * flliper 1 x2 = 340
			 * flipper 1 y1 = 1050
			 * flliper 1 x1 = 240
			 */
			if ((pelotax>240 *MODX && pelotax<340 *MODX && 
			   pelotay> (1050*MODY_REAL +((pelotax-240*MODX)*(1110*MODY_REAL-1050*MODY_REAL)/(340*MODX-240*MODX)))) ||
			   (pelotax>240*MODX && pelotax<340*MODX && 
			   (pelotay+32 *MOD_BOLA)> (1050*MODY_REAL + ((pelotax-240*MODX)*(1110*MODY_REAL-1050*MODY_REAL)/(340*MODX-240*MODX)))) ) {
				alt=pelotay-1110*MODY_REAL;
				if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<2) alt=2;
				pelotay=1010 *MODY_REAL;
				dy=(-1)*(pelotax-240 *MODX)/2  -alt *MODY_REAL -(rand() % (alt *MODY_REAL*4));
				dx=(pelotax-240 *MODX)/4 + (rand() % (alt *MODY_REAL/2+1) +5);
				puntaje+=500;
			};


		layout[flipper_Ldwn]->visible = 0; 
		layout[flipper_Lup]->visible = 1 ; 

	   	/* chequeamos si se acaba de "soltar" la tecla */
		} else if (layout[flipper_Ldwn]->visible != 1){ 

			/* reproducir sonido de un flipper yendo hacia abajo */
                	play_sound(layout[flipper_Ldwn]->sonido, 128);

	     		layout[flipper_Lup]->visible = 0; 
			layout[flipper_Ldwn]->visible = 1 ; 
		};
	} else if ((y>200) && (x>105) && (x<210)) {
		if (tecla_space==0) {
			/* reproducir sonido del disparador yendo hacia atras */
               		play_sound(disparador_atras, 128);
			SDL_Delay(100);
			tecla_space=1;
		}
			
		else if (tecla_space==1) {
		/* reproducir sonido del disparador */
               	play_sound(disparador_snd, 128);


		tecla_space = 0;
		if ((pelotax > 700 *MODX) && (pelotay > 1070 *MODY_REAL)) {
			dy=potencia_disparador*-1;
			dx=0;
			pelotay = 1080 *MODY_REAL;

			/*
			 * reproducimos un sonido de bola deslizando solo si la potencia del
			 * disparador es mayor a 50
			 */
		//	potencia_disparador = 50;
			if (potencia_disparador > 50 *MODY_REAL) {
               			play_sound(bola_start_snd, 128);
				
				/* subir el volumen de la musica */
				if (enable_sound) Mix_VolumeMusic(60);
			};
		};
		}
		potencia_disparador = 0;
	} else if ((y>200) && (x>209) && (x<321)) {
	   	/* chequeamos si se acaba de pulsar la tecla */
		if (layout[flipper_Rup]->visible != 1) { 

			/* reproducir sonido de un flipper yendo hacia arriba */
                	play_sound(layout[flipper_Rup]->sonido, 128);

			/* chequeamos si la bola se encuentra en posicion 
			 * de impacto del flipper, entonces le damos potencia 
			 * y direccion
			 * flipper 2 y2 = 1110
			 * flliper 2 x2 = 510
			 * flipper 2 y1 = 1050
			 * flliper 2 x1 = 410
			 */
			if ((pelotax > 410 *MODX && pelotax < 510 *MODX && 
			   pelotay > (1050 *MODY_REAL+((pelotax-410 *MODX)*(1110 *MODY_REAL-1050 *MODY_REAL)/(510 *MODX-410 *MODX)))) ||
			   (pelotax > 410 *MODX && pelotax < 510 *MODX && 
			   (pelotay+32 *MOD_BOLA) > (1050 *MODY_REAL+((pelotax-410 *MODX)*(1110 *MODY_REAL-1050 *MODY_REAL)/(510 *MODX-410 *MODX)))) ) {
				alt=pelotay-1110 *MODY_REAL;
				//if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<2) alt=2;
				if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<4) alt=4;
				pelotay=1010 *MODY_REAL;
				
				dy=(-50 *MODY_REAL)+(pelotax-410 *MODX)/2  -alt *MODY_REAL -(rand() % (alt *MODY_REAL*4));
				dx=(-20 *MODX)+(pelotax-410 *MODX)/5 -(rand() % (alt *MODY_REAL/2+1) +5);
				puntaje+= 500;
			};

 	     	layout[flipper_Rdwn]->visible = 0; 
		layout[flipper_Rup]->visible = 1; 

	   	/* chequeamos si se acaba de "soltar" la tecla */
		} else if (layout[flipper_Rdwn]->visible != 1){ 

			/* reproducir sonido de un flipper yendo hacia abajo */
                	play_sound(layout[flipper_Rdwn]->sonido, 128);

	   		layout[flipper_Rup]->visible = 0; 
			layout[flipper_Rdwn]->visible = 1; 
		};
	   }

};


void manejador_tecla(SDL_KeyboardEvent key){
	int alt;	/* altura utilizada como incremento en el golpe de los
			   flippers a la bola. alt = pelotay - 1050 */

	switch(key.keysym.sym){
           case SDLK_s:	
	   if (key.state == SDL_PRESSED)
	   {
	   	/* chequeamos si se acaba de pulsar la tecla */
		if (layout[flipper_Lup]->visible != 1){

			/* reproducir sonido de un flipper yendo hacia arriba */
                	play_sound(layout[flipper_Lup]->sonido, 128);

			/* chequeamos si la bola se encuentra en posicion 
			 * de impacto del flipper, entonces le damos potencia 
			 * y direccion
			 * flipper 1 y2 = 1110
			 * flliper 1 x2 = 340
			 * flipper 1 y1 = 1050
			 * flliper 1 x1 = 240
			 */
			if ((pelotax>240 *MODX && pelotax<340 *MODX && 
			   pelotay> (1050*MODY_REAL +((pelotax-240*MODX)*(1110*MODY_REAL-1050*MODY_REAL)/(340*MODX-240*MODX)))) ||
			   (pelotax>240*MODX && pelotax<340*MODX && 
			   (pelotay+32 *MOD_BOLA)> (1050*MODY_REAL + ((pelotax-240*MODX)*(1110*MODY_REAL-1050*MODY_REAL)/(340*MODX-240*MODX)))) ) {
				alt=pelotay-1110*MODY_REAL;
				if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<2) alt=2;
				pelotay=1010 *MODY_REAL;
				//dy=(-1)*(pelotax-240 *MODX)/2  -alt *MODY_REAL -(rand() % (alt *MODY_REAL*4)+10);
				dy=(-1)*(pelotax-240 *MODX)/2  -alt *MODY_REAL -(rand() % (alt *MODY_REAL*4+10));
				//dx=(pelotax-240 *MODX)/5 + (rand() % (alt *MODY_REAL/2+1) +10);
				dx=(pelotax-240 *MODX)/5 + (rand() % (alt *MODY_REAL/2+1 +10));
				puntaje+= 500;
			};



		};
		layout[flipper_Ldwn]->visible = 0; 
		layout[flipper_Lup]->visible = 1 ; 
	   }
	   else if (key.state == SDL_RELEASED)
	   {
	   	/* chequeamos si se acaba de "soltar" la tecla */
		if (layout[flipper_Ldwn]->visible != 1){ 

			/* reproducir sonido de un flipper yendo hacia abajo */
                	play_sound(layout[flipper_Ldwn]->sonido, 128);
		};
	     	layout[flipper_Lup]->visible = 0; 
		layout[flipper_Ldwn]->visible = 1 ; 
	   }
	   break;

	   case SDLK_l:
	   if (key.state == SDL_PRESSED)
 	   {
	   	/* chequeamos si se acaba de pulsar la tecla */
		if (layout[flipper_Rup]->visible != 1){ 

			/* reproducir sonido de un flipper yendo hacia arriba */
                	play_sound(layout[flipper_Rup]->sonido, 128);

			/* chequeamos si la bola se encuentra en posicion 
			 * de impacto del flipper, entonces le damos potencia 
			 * y direccion
			 * flipper 2 y2 = 1110
			 * flliper 2 x2 = 510
			 * flipper 2 y1 = 1050
			 * flliper 2 x1 = 410
			 */
			if ((pelotax > 410 *MODX && pelotax < 510 *MODX && 
			   pelotay > (1050 *MODY_REAL+((pelotax-410 *MODX)*(1110 *MODY_REAL-1050 *MODY_REAL)/(510 *MODX-410 *MODX)))) ||
			   (pelotax > 410 *MODX && pelotax < 510 *MODX && 
			   (pelotay+32 *MOD_BOLA) > (1050 *MODY_REAL+((pelotax-410 *MODX)*(1110 *MODY_REAL-1050 *MODY_REAL)/(510 *MODX-410 *MODX)))) ) {
				alt=pelotay-1110 *MODY_REAL;
				//if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<2) alt=2;
				if (alt>20 *MODY_REAL) alt=20 *MODY_REAL; else if (alt<4) alt=4;
				pelotay=1010 *MODY_REAL;
				
				dy=(-50 *MODY_REAL)+(pelotax-410 *MODX)/2  -alt *MODY_REAL -(rand() % (alt *MODY_REAL*4));
				dx=(-20 *MODX)+(pelotax-410 *MODX)/5 -(rand() % (alt *MODY_REAL/2+1) +5);
				puntaje+= 500;
			};

		};
 	     	layout[flipper_Rdwn]->visible = 0; 
		layout[flipper_Rup]->visible = 1; 
	   }
	   else if (key.state == SDL_RELEASED)
	   {
	   	/* chequeamos si se acaba de "soltar" la tecla */
		if (layout[flipper_Rdwn]->visible != 1){ 

			/* reproducir sonido de un flipper yendo hacia abajo */
                	play_sound(layout[flipper_Rdwn]->sonido, 128);
		};
	   	layout[flipper_Rup]->visible = 0; 
		layout[flipper_Rdwn]->visible = 1; 
	   }
	   break;

	   case SDLK_SPACE:
	   if (key.state == SDL_PRESSED)
	   {
	   	if (tecla_space==0)
			/* reproducir sonido del disparador yendo hacia atras */
               		play_sound(disparador_atras, 128);
			
		tecla_space = 1;
	   }
	   else if (key.state == SDL_RELEASED)
	   {
		/* reproducir sonido del disparador */
               	play_sound(disparador_snd, 128);

		tecla_space = 0;
		if ((pelotax > 700 *MODX) && (pelotay > 1070 *MODY_REAL)) {
			dy=(-1)*potencia_disparador;
			dx=0;
			pelotay = 1080 *MODY_REAL;

			/*
			 * reproducimos un sonido de bola deslizando solo si la potencia del
			 * disparador es mayor a 50
			 */
			if (potencia_disparador > 50 *MODY_REAL) {
               			play_sound(bola_start_snd, 128);
				
				/* subir el volumen de la musica */
				if (enable_sound) Mix_VolumeMusic(60);
				puntaje+= 2000;
			};
		};
		potencia_disparador = 0;
	   }
	   break;

	   default:;
	}

}
