/*
 * Linball - un pinball 2D multiplataforma escrito en C + SDL (desarrollado en Linux)
 *
 * COSAS FEAS DEL CODIGO QUE QUISIERA CAMBIAR (pero que en el estado actual
 * en que estan funcionan):
 *
 * - la "V" roja donde se posiciona la pelota (en pinball.bmp) antes de empezar
 *   el nivel de juego es un truco para que la pelota caiga y se posicione
 *   sin moverse. dx tiene que ser igual a 0, y pelotax = 743 (pelotay = 600)
 *
 * - la posicion de la tabla inicial es -700 (y0pantalla).
 * 
 * Los valores anteriores estan dentro del codigo de juego como inicializacion.
 * Lo feo de esos valores es que si alguien (yo talvez) cambia un valor de 
 * esos la pelota caerá mal al comenzar el nivel y no se posicionará delante
 * del "resorte" disparador
 *
 * - en colisiones() no se hara un efecto de sonido cuando la pelota "rebote" 
 *   en alguna parte inferior. Esto es porque cuando la pelota es retenida
 *   por los flippers en realidad lo que sucede es que rebota en ambos lados
 *   constantemente. Si hacemos un efecto de sonido en esos rebotes se escucharia
 *   una especie de "ametralladora".
 *
 */

#define MAX_OBJ 20
#define NUM_OBJ 10


/* macros para modificar la resolucion del juego a 320x240 (tabla 320x480) */

/* macros para la bola */
#define ANCHO_BOLA 32	/* para 320x240 el ancho de la bola es 12/
			 * para 800x600 el ancho de la bola es 32
			 */ 
#define MOD_BOLA ANCHO_BOLA / 32

/* macros del ancho y largo de la pantalla y de la tabla*/
#define ANCHO 800		/* puede ser 320 u 800 */
#define LARGO 600		/* puede ser 240 u 600 */
#define LARGO_TABLA 1200	/* puede ser 480 u 1200 */
#define MODX ANCHO / 800
#define MODY LARGO / 600
#define MODY_REAL LARGO_TABLA / 1200


/*#define DEBUG1*/
/*#define DEBUG2*/
// #define DEBUG3

struct object {
       int posx,posy;
       int visible; /*booleano para saber si dibujarlo o no*/
       SDL_Surface * imagen;
       Mix_Chunk * sonido;
};

enum objects{fondo=0,fondo_dummy,fondo_sup,fondo_sup_dummy, fondo_objetos, 
	     aquibonus, ball,flipper_Ldwn,flipper_Rdwn,flipper_Lup,flipper_Rup,
	     flipper_LdwnR,flipper_RdwnR,flipper_LupR,flipper_RupR, bumperi1,
	     bumperi2, bumperi3, bumpizq, bumpder, tabla_luz1, tabla_luz2, tabla_luz3, last};

enum luces {roja, verde, azul, magenta, ult_luz};

struct luces_colores {
       SDL_Surface * imagen;
       Mix_Chunk * sonido;
};

struct luz {
	int posx;
	int posy;
	int visible;
	enum luces clase;
	int modo;
	int inc;
};

SDL_Surface * image, *scr, *pelota,*temp,*temp2,*dummy;
SDL_Surface *fondoi1, *fondoi2;
SDL_Rect dest;


/* profundidad de colores */
const int prof=16;

/* para habilitar sonido */
int enable_sound=1;

Mix_Music *music = NULL;

/* sonido de la bola ingresando al tablero cuando inicia el nivel */
Mix_Chunk * bola_cae_snd;
Mix_Chunk * bola_doingdown;
Mix_Chunk * doingdown;
Mix_Chunk * bola_start_snd;
Mix_Chunk * disparador_snd, *disparador_atras;
Mix_Chunk * puntaje_s;

int phaserChannel = -1;
	
/* Font a utilizar */
TTF_Font *font, *font_bonus;


/* Variables del nivel (deberian estar todas dentro de una estructura) */
int potencia_disparador;
int nivel;
int bolas_por_jugar;
int chance_izq;
int chance_der;
int puntaje, puntaje_anterior;
int tecla_space;
char banner[80];	/* texto en la parte superior de la pantalla */
char banner_b[80];	/* texto bonus en la parte superior de la pantalla */

int juego_finalizado;
int puente;		/* esta variable indica si la bola esta abajo o en el 
			 * puente 
			 */

/* parametros del tiempo para calcular el FPS */
//struct timeval *tv;
//tv = malloc(sizeof(struct timeval));
int prev_ticks = 0, cur_ticks = 0; /* for keeping track of timing */




int bonus_timer;
enum personajes  { belgrano, moreno, borges, guevara, fangio, favaloro,
		   fontanarrosa, sanmartin, storni, piazzolla, tato,
		   olmedo, sabato, lastpersonaje };

char *bonus_banner;
char *bonus_text[lastpersonaje]={ "                              MANUEL BELGRANO (BUENOS AIRES, 3 DE JUNIO DE 1770 - 20 DE JUNIO DE 1820) FUE UN INTELECTUAL, ABOGADO, POLITICO Y MILITAR ARGENTINO LUCHADOR DE LA GUERRA DE LA INDEPENDENCIA Y CREADOR DE LA BANDERA ARGENTINA.",
			"                              MARIANO MORENO NACIO EN BUENOS AIRES EL 23 DE SETIEMBRE DE 1778 Y FALLECIO EN ALTA MAR EL 4 DE MARZO DE 1811. ABOGADO, PERIODISTA Y POLITICO ARGENTINO, TUVO UN ROL DECISIVO EN LA REVOLUCION DE MAYO.",
			"                              JORGE FRANCISCO ISIDORO LUIS BORGES (BUENOS AIRES, 24 DE AGOSTO DE 1899 - GINEBRA, 14 DE JUNIO DE 1986), FUE UN ESCRITOR ARGENTINO, UNO DE LOS AUTORES MAS DESTACADOS DE LA LITERATURA EN ESPANOL DEL SIGLO XX.",
			"                              ERNESTO CHE GUEVARA (14 DE JUNIO DE 1928 EN ROSARIO, PROVINCIA DE SANTA FE, ARGENTINA - 9 DE OCTUBRE DE 1967 EN LA HIGUERA, BOLIVIA), FUE UN MEDICO, POLITICO Y GUERRILLERO ARGENTINO-CUBANO, CUYA FIGURA DESPIERTA GRANDES PASIONES TANTO A FAVOR COMO EN CONTRA.",
			"                              JUAN MANUEL FANGIO (* BALCARCE, ARGENTINA, 24 DE JUNIO, 1911 - BUENOS AIRES, 17 DE JULIO, 1995) PENTACAMPEON MUNDIAL DE FORMULA 1, ES CONSIDERADO UNO DE LOS MEJORES PILOTOS DE FORMULA 1 DE LA HISTORIA, Y POR MUCHOS EXPERTOS INTERNACIONALES COMO EL MEJOR PILOTO DEPORTIVO DE TODOS LOS TIEMPOS.",
			"                              RENE GERONIMO FAVALORO (*12 DE JULIO DE 1923 - 20 29 DE JULIO DE 2000) FUE UN FAMOSO CIRUJANO TORACICO ARGENTINO, QUIEN REALIZO EL PRIMER BYPASS AORTO CORONARIO EN EL MUNDO.",
			"                              ROBERTO ALFREDO FONTANARROSA (ROSARIO, 26 DE NOVIEMBRE DE 1944 - 19 DE JULIO DE 2007), APODADO EL NEGRO, FUE UN HUMORISTA GRAFICO Y ESCRITOR ARGENTINO.",
			"                              JOSE FRANCISCO DE SAN MARTIN MATORRAS, ALSO KNOWN AS JOSE DE SAN MARTIN (25 FEBRUARY 1778 - 17 AUGUST 1850), WAS AN ARGENTINE GENERAL AND THE PRIME LEADER OF THE SOUTHERN PART OF SOUTH AMERICA'S SUCCESSFUL STRUGGLE FOR INDEPENDENCE FROM SPAIN.",
			"                              ALFONSINA STORNI MARTIGNONI (* SALA CAPRIASCA, SUIZA; 29 DE MAYO DE 1892 - MAR DEL PLATA, ARGENTINA; 25 DE OCTUBRE DE 1938), POETA Y ESCRITORA ARGENTINA DEL POSMODERNISMO.",
			"                              ASTOR PANTALEON PIAZZOLLA (MAR DEL PLATA, 11 DE MARZO DE 1921 - BUENOS AIRES, 4 DE JULIO DE 1992) FUE UN BANDONEONISTA Y COMPOSITOR ARGENTINO.",
			"                              TATO BORES ES EL NOMBRE ARTISTICO DEL HUMORISTA ARGENTINO MAURICIO BORENSZTEIN, (BUENOS AIRES, 27 DE ABRIL DE 1927 - IDEM. 11 DE ENERO DE 1996). SI BIEN ACTUO EN CINE, TEATRO Y TELEVISION, ES EN ESTE ULTIMO MEDIO DONDE CON SU HUMOR POLITICO MARCO A GENERACIONES DE ARGENTINOS. ES APODADO EL ACTOR COMICO DE LA NACION.",
			"                              ALBERTO NEGRO OLMEDO (ROSARIO, 24 DE AGOSTO DE 1933 - MAR DEL PLATA, 5 DE MARZO DE 1988) FUE UN ACTOR Y HUMORISTA ARGENTINO.", 
			"                              ERNESTO SABATO (ROJAS, PROVINCIA DE BUENOS AIRES; 24 DE JUNIO DE 1911) ES UN ESCRITOR, ENSAYISTA Y ARTISTA PLASTICO ARGENTINO. HA ESCRITO TRES NOVELAS, EL TUNEL, SOBRE HEROES Y TUMBAS Y ABADDON EL EXTERMINADOR, ASI COMO DIFERENTES ENSAYOS SOBRE LA CONDICION HUMANA."

		        };


struct object * layout[last];
struct luces_colores * lucesd[ult_luz];		/* datos (imagen y sonido) de las
						 * luces a utilizar por clase en
						 * lucest */
struct luz * lucest[20];	/* luces en la tabla */


/*y0pantalla indica el valor de comienzo del fondo que se esta mostrando en pantalla*/
int y0pantalla=-700 *MODY;

/* posicion de la pelota */
int pelotax, pelotay, yp;

/* dx y dy son el desplazamiento en x e y */
int dx = 0;
int dy = 0;

/* es el tope y del fondo */
int maxy = 1130 *MODY_REAL;

/* es el tope maximo donde la pelota empieza a desacelerar */
int maxytop = 200 *MODY;

/* randy es la variable aleatoria de velocidad en y
 *  * utilizada en las pruebas
 *   */
int randy = 50;

/*
 * color_clave : utilizado para las colisiones
 * pix: el puntero a la imagen que se utilizara para las colisiones
 */
int color_clave;
Uint16 * pixel ;//aca cambie el codigo, verificar

