#!/bin/bash

borrar_temp() {
	cd /tmp
	rm -rf $TEMP
}


TEMP=/tmp/linball.$$

mkdir $TEMP || exit 1
cd $TEMP

echo "Obteniendo cross compiler, codigo fuente de linball, art y archivos para auto ejecucion ..."
wget http://200.123.158.181/projects/linball/cross-tools-to-create-windows-binaries.tar.gz
wget http://200.123.158.181/projects/linball/linball.tar.gz
wget http://200.123.158.181/projects/linball/linball_art.tar.gz
wget http://200.123.158.181/projects/linball/auto-ejecutable-win.tar.gz
wget http://200.123.158.181/projects/linball/runtime-libraries-SDL-1.2.13-win32.tar.gz

echo "Desempaquetando cross-tools-to-create-windows-binaries.tar.gz ..."
tar xvzf cross-tools-to-create-windows-binaries.tar.gz 2>&1 1>/dev/null

echo "Desempaquetando linball.tar.gz ..."
tar xvzf linball.tar.gz 2>&1 1>/dev/null

echo "Desempaquetando linball_art.tar.gz ..."
tar xvzf linball_art.tar.gz 2>&1 1>/dev/null

echo "Desempaquetando auto-ejecutable-win.tar.gz ..."
tar xvzf auto-ejecutable-win.tar.gz 2>&1 1>/dev/null

echo "Desempaquetando runtime-libraries-SDL-1.2.13-win32.tar.gz ..."
tar xvzf runtime-libraries-SDL-1.2.13-win32.tar.gz 2>&1 1>/dev/null


cd linball

echo "Intentando con cross compiler que utiliza glibc_2.3"
$TEMP/cross-tools/bin/glibc_2.3/i586-mingw32msvc-gcc	\
	-I$TEMP/cross-tools/sdl/include/SDL 		\
	-L$TEMP/cross-tools/sdl/lib 			\
	-o linball.exe linball.c			\
	-lSDL -lSDL_mixer -lSDL_ttf -lmingw32 -lSDLmain \
	-mwindows 					\
	$($TEMP/cross-tools/sdl/bin/i386-mingw32msvc-sdl-config --libs --cflags)
	 $TEMP/cross-tools/bin/glibc_2.3/i586-mingw32msvc-strip linball.exe

if [ $? != "0" ] ; then
	echo "Intentando con cross compiler que utiliza glibc_2.4"
	$TEMP/cross-tools/bin/i386-mingw32-gcc			\
		-I$TEMP/cross-tools/sdl/include/SDL 		\
		-L$TEMP/cross-tools/sdl/lib 			\
		-o linball.exe linball.c			\
		-lSDL -lSDL_mixer -lSDL_ttf -lmingw32 -lSDLmain \
		-mwindows 					\
		$($TEMP/cross-tools/sdl/bin/i386-mingw32msvc-sdl-config --libs --cflags)

	 $TEMP/cross-tools/bin/i386-mingw32-strip linball.exe

fi


cd $TEMP
cp linball/linball.exe linball_art/
cp runtime-libraries-SDL-1.2.13-win32/* linball_art/

cd linball_art

which 7zr
if [ $? != "0" ] ; then
	echo "No encuentro el ejecutable 7zr del paquete p7zip. Saliendo..."
	borrar_temp
	exit 1
fi

7zr a -y linball.7z *


cd $TEMP
cp auto-ejecutable-win/* linball_art/

cd linball_art
cat 7zS.sfx 7zip.conf linball.7z >linball_selfextracting.exe
cp linball_selfextracting.exe /tmp

if [ $? != "0" ] ; then
	echo "No pude copiar el ejecutable linball_selfextranting.exe a /tmp. Saliendo..."
	borrar_temp
	exit 1
fi



borrar_temp
echo "Paquete auto ejecutable para Windows hecho (/tmp/linball_selfextracting.exe ." 
exit 0
